#ifndef TVCDRIVER_INCLUDED
#define TVCDRIVER_INCLUDED

#include "EPPPort.hh"

//this should inherit from a class that only has virtual void functions
class TvcDriver
{
public:
  TvcDriver(EPPPort &rTPort);
  ~TvcDriver(void);

  void DumpRegisters(void);
  void ClearRegisters(void);
  void PrintStatus(void);

  void TestRam(void); //not implemented

  void Blank(unsigned long value = 0);

  void DrawPixel(int xPos, int yPos, unsigned char pixValue);
  void DrawLine(int xStart, int yStart, int xEnd, int yEnd, unsigned char pixValue);

  void ReadValue(unsigned long fbAddress, unsigned long &rValue);
  void WriteValue(unsigned long fbAddress, unsigned long newValue);

protected:
  void WriteFBAddress(unsigned long fbAddress);
  void WaitOnBW(void); //poll for completion of the block writer
  void WaitOnBR(void); //same for block reader
  void WaitOnPW(void); //same for pixel writer

  EPPPort &rPort;
};

#endif //TVCDRIVER_INCLUDED
