#include <iostream>
#include <iomanip>

#include "EPPPort.hh"
#include "TvcDriver.hh"

using namespace std;

int DoMenu(void)
{
  while(true)
    {
      cout << "enter 1 for blank" << endl;
      cout << "enter 2 for multi-color blank" << endl;
      cout << "enter 3 for lines" << endl;
      cout << "enter 4 for quit" << endl;

      int sel = 0;
      cin >> sel;
      if(sel <= 0 || sel > 4)
	{
	  cout << "print unknown selection\n\n" << endl;
	  continue;
	};

      return sel;
    };
};


int main(void)
{
  EPPPort port;
  if( !port.Initialize() ) return -1;

  if( port.CheckAndClearTimeout() )
    {
      cout << "initial timeout set" << endl;
    };
  port.WriteAddress(0);
  port.CheckAndClearTimeout();

  //port.TestDataLinkQuality();

  /*
  driver.DumpRegisters(); 

  driver.WriteValue(0, 0xFFFFFFFF);
  driver.DumpRegisters();

  unsigned long result = 0;
  driver.ReadValue(0, result);
  driver.DumpRegisters();

  cout << "result: " << hex << result << dec << endl;
  return 0;
  */

  TvcDriver driver(port);
  driver.PrintStatus();

  bool done = false;
  do
    { 
      int sel = DoMenu();
      switch(sel)
	{
	case 1:
	  driver.Blank();
	  break;
	case 2:
	  cout << "starting red fill" << endl;
	  driver.Blank(0xC0C0C0C0);
	  cout << "starting green fill" << endl;
	  driver.Blank(0x38383838);
	  cout << "starting blue fill" << endl;
	  driver.Blank(0x07070707);
	  cout << "starting white fill" << endl;
	  driver.Blank(0xffffffff);
	  cout << "starting blank" << endl;
	  driver.Blank();
	  break;
	case 3:
	  cout << "drawing lines" << endl;
	  driver.DrawLine(0,0, 640,480, 0xFF);
	  driver.DrawLine(640,0, 0,480, 0xC0); 
	  driver.DrawLine(0,480/2, 640,480/2, 0x38);
	  driver.DrawLine(640/2,0, 640/2,480, 0x07); 
	  break;
	default:
	  done = true;
	};
    }while(!done);
  
  if( port.CheckAndClearTimeout() )
    {
      cout << "final timeout set" << endl;
    }else
      cout << "final timeout NOT set" << endl;

  port.CloseAll();
  return 0;
}
